Summary: clockspeed
Summary(ja): clockspeed
Name: clockspeed
Version: 0.62
Release: 0vl1
License: BSD ?
Group: System Environment/Daemons
URL: http://cr.yp.to/clockspeed.html
Source0: http://cr.yp.to/clockspeed/clockspeed-%{version}.tar.gz
Source1: http://www.org3.net/software/clockspeed-service-%{version}.tar.gz

Patch0: clockspeed-%{version}.errno.patch

Patch100: clockspeed-%{version}.install.patch

Buildroot: %{_tmppath}/%{name}-%{version}-root
Requires: glibc >= 2.0.6, leapsecs >= 1.0

#Distribution: Vine Linux
#Vendor: Project Vine
Packager: NOGUCHI Shoji <noguchi@org3.net>

%description
clockspeed uses a hardware tick counter to compensate for a persistently fast or slow system clock. Given a few time measurements from a reliable source, it computes and then eliminates the clock skew.

sntpclock checks another system's NTP clock, and prints the results in a format suitable for input to clockspeed. sntpclock is the simplest available NTP/SNTP client.

taiclock and taiclockd form an even simpler alternative to SNTP. They are suitable for precise time synchronization over a local area network, without the hassles and potential security problems of an NTP server.

This version of clockspeed can use the Pentium RDTSC tick counter or the Solaris gethrtime() nanosecond counter.

%prep
%setup -q -a 1
%patch0 -p1

%patch100 -p1

echo %{_sysconfdir}/clockspeed > conf-home
echo %{_bindir} > conf-bin
echo %{_mandir} > conf-man
echo %__cc $RPM_OPT_FLAGS > conf-cc
echo %__cc -s $RPM_OPT_FLAGS > conf-ld
%__rm -f *.orig *~

%build
%__make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && %__rm -rf $RPM_BUILD_ROOT

%__mkdir_p $RPM_BUILD_ROOT%{_bindir}
%__mkdir_p $RPM_BUILD_ROOT%{_mandir}
%__mkdir_p $RPM_BUILD_ROOT%{_sysconfdir}/clockspeed/etc

%__cat hier.c | \
  %__grep "^  [cdhp](" | \
  %__sed -e "s/^  \([cdhp]\)(\(.*\));/\1,\2/" | \
  %__sed -e "s/[\"]//g" | \
  %__awk -F "," '{ \
    #if($1 == "h") \
    #{ print "%attr(" $5 ",root,root) %dir " $2 } \
    if($1 == "c") \
    { \
      if(substr($3,1,3) == "man") \
      { print "%attr(" $7 ",root,root) " $2 "/" $3 "/" $4 ".gz" } \
      else \
      { print "%attr(" $7 ",root,root) " $2 "/" $3 "/" $4 } \
    } \
    if($1 == "p") \
    { print "%attr(" $6 ",root,root) " $2 "/" $3 } \
    #if($1 == "d") \
    #{ print "%attr(" $6 ",root,root) %dir " $2 "/" $3 } \
  }' | \
  %__sed -e "s!auto_home!%{_sysconfdir}/clockspeed!" \
	 -e "s!auto_bin!%{_bindir}!" \
         -e "s!auto_man!%{_mandir}!" \
  > clockspeed-%{version}.files

echo $RPM_BUILD_ROOT%{_sysconfdir}/clockspeed > conf-home
echo $RPM_BUILD_ROOT%{_bindir} > conf-bin
echo $RPM_BUILD_ROOT%{_mandir} > conf-man

%__rm auto_*.o install instcheck
%__make install instcheck

./install
./instcheck

ETC=$RPM_BUILD_ROOT%{_sysconfdir}
%__mkdir_p $ETC/clockspeed/service/clockspeed/env
%__install -m 755 service/clockspeed/run      $ETC/clockspeed/service/clockspeed/run
%__install -m 644 service/clockspeed/env/PATH $ETC/clockspeed/service/clockspeed/env/PATH
%__install -m 644 service/clockspeed/env/NTP  $ETC/clockspeed/service/clockspeed/env/NTP

%clean
%__rm -rf $RPM_BUILD_ROOT


%files -f clockspeed-%{version}.files
%defattr(-,root,root)

%dir %{_sysconfdir}/clockspeed
%dir %{_sysconfdir}/clockspeed/etc
%dir %{_sysconfdir}/clockspeed/service
%dir %{_sysconfdir}/clockspeed/service/clockspeed
%dir %{_sysconfdir}/clockspeed/service/clockspeed/env

%config %{_sysconfdir}/clockspeed/service/clockspeed/run
%config %{_sysconfdir}/clockspeed/service/clockspeed/env/PATH
%config %{_sysconfdir}/clockspeed/service/clockspeed/env/NTP

